function [x,y] = cardioidfunction(bs,s)
% Geometry file defining the geometry of a cardioid

switch nargin
  case 0 % four edge segments
    x = 4;
    return
  case 1
    A = [0  4   8   12  % start parameter values
         4  8   12  16  % end parameter values
         1  1   1   1   % region label to left
         0  0   0   0]; % region label to right
    x = A(:,bs); % return requested columns
    return
  case 2
    x = zeros(size(s));
    y = zeros(size(s));
    if numel(bs) == 1 % bs might need scalar expansion
      bs = bs*ones(size(s));  % expand bs
    end

    cbs = find(bs < 3); % upper half of cardioid
    x(cbs) = s(cbs).^4/512 - 3*s(cbs).^2/16 + 4;
    y(cbs) = s(cbs).*(64 - s(cbs).^2).^(3/2)/512;
    cbs = find(bs >= 3);  % lower half of cardioid
    s(cbs) = 16 - s(cbs); % take the parameter corresponding to the reflection
    x(cbs) = s(cbs).^4/512 - 3*s(cbs).^2/16 + 4;  % keep x
    y(cbs) = -s(cbs).*(64 - s(cbs).^2).^(3/2)/512;  % negate y
    return
end
