function [x,y] = donutfunction(bs,s)
% Geometry file defining the geometry of a doughnut

switch nargin
  case 0 % eight edge segments
    x = 8;
    return
  case 1
    % outer circle
    A1 = [0     pi/2  pi      3*pi/2  % start parameter values
          pi/2  pi    3*pi/2  2*pi    % end parameter values
          1     1     1       1       % region label to left
          0     0     0       0];     % region label to right
    % inner circle
    A2 = [0     pi/2  pi      3*pi/2  % start parameter values
          pi/2  pi    3*pi/2  2*pi    % end parameter values
          0     0     0       0       % region label to left
          1     1     1       1];     % region label to right
    A = [A1, A2];
    x = A(:,bs); % return requested columns
    return
  case 2
    x = zeros(size(s));
    y = zeros(size(s));
    if numel(bs) == 1 % bs might need scalar expansion
      bs = bs*ones(size(s));  % expand bs
    end

    cbs = find(bs < 5); % outer circle
    x(cbs) = 2*cos(s(cbs));
    y(cbs) = 2*sin(s(cbs));
    cbs = find(bs > 4);  % inner circle
    x(cbs) = cos(s(cbs));
    y(cbs) = sin(s(cbs));

    return
end
