function [x,y] = squarefunction(bs,s)
% Geometry file defining the geometry of a square

switch nargin
  case 0 % four edge segments
    x = 4;
    return
  case 1
    A = [0  1   2   3   % start parameter values
         1  2   3   4   % end parameter values
         1  1   1   1   % region label to left
         0  0   0   0]; % region label to right
    x = A(:,bs); % return requested columns
    return
  case 2
    x = zeros(size(s));
    y = zeros(size(s));
    if numel(bs) == 1 % bs might need scalar expansion
      bs = bs*ones(size(s));  % expand bs
    end

    cbs = find(bs == 1); % right edge
    x(cbs) = 1.0;
    y(cbs) = s(cbs);
    cbs = find(bs == 2); % top edge
    x(cbs) = 2-s(cbs);
    y(cbs) = 1.0;
    cbs = find(bs == 3); % left edge
    x(cbs) = 0.0;
    y(cbs) = 3-s(cbs);
    cbs = find(bs == 4); % bottom edge
    x(cbs) = s(cbs)-3;
    y(cbs) = 0.0;
    return
end
